<template>
  <v-card class="elevation-12">
      <v-form>
          <v-card-title>Connexion</v-card-title>
          <v-card-text>
            <v-text-field  
              v-model="email" 
              type="email"
              placeholder="Email"
              id="email"
              autocomplete="username"
              :error-messages="emailErrors"
            />
          </v-card-text>
          <v-card-text>
            <v-text-field  
              v-model="password" 
              type="password"
              placeholder="Password"
              id="password"
              autocomplete="current-password"
              :error-messages="passErrors"
            />
          </v-card-text>

          <v-card-actions>
            <v-btn color="secondary" light type="submit" @click="register">
              Connexion
            </v-btn>
          </v-card-actions>
      </v-form>
      <v-card-text class="login-text">
        <span>Pas encore inscrit ? </span> 
        <router-link :to="{ name: 'register' }" style="text-decoration: none;">
          <b>Cliquez ici pour créer un compte</b>
        </router-link>
      </v-card-text>
      <v-card-text class="login-text">
        <router-link :to="{ name: 'resetPasswordEmail' }" style="text-decoration: none;">
          <b>Mot de pass oublié ?</b>
        </router-link>
      </v-card-text>
  </v-card>
</template>

<script>
import { validationMixin } from 'vuelidate';
import { required, email, minLength } from 'vuelidate/lib/validators';
export default {
  mixins: [validationMixin],
  validations: {
		email: { required, email },
		password : {required, minLength: minLength(6)},
	},
  data() {
    return {
      email: '',
      password:'',
      errors: [],
    }
  },
  props: {
    isLoading: {
      type: Boolean,
      required: false,
      default: () => false
    }
  },
  computed: {
		emailErrors () {
			const errors = []
			if (!this.$v.email.$dirty) return errors
			!this.$v.email.email && errors.push('Email non valide')
			!this.$v.email.required && errors.push('Email requis')
			return errors
		},
		passErrors () {
			const errors = []
			if (!this.$v.password.$dirty) return errors
			!this.$v.password.minLength && errors.push('Mot de passe trop court')
			!this.$v.password.required && errors.push('Mot de passe requis')
			return errors
		}
	},
  methods: {
    register: function (event) {
      event.preventDefault();
      this.$v.$touch();
      if (this.$v.$invalid) {
        return false;
      }
      let user = {
        email : this.email,
        password : this.password
      }
      this.$emit('loggedIn', user);
    }
    
  }
}
</script>

<style lang="scss" scoped>
 .login-text{
   padding: 8px 16px;
 }
</style>